/* Made by Hagrit, for XLightingStormL
** Version 1.0
*/ 

void main(void) {
	
	rmSetStatusText("",0.01);
	
	int mapSizeMultiplier = 1;
   
	int playerTiles = 6500;
	if(cMapSize == 1)
	{
		playerTiles = 9750;
		rmEchoInfo("Large map");
		mapSizeMultiplier = 1;
	}
	if (cMapSize == 2)
	{
		playerTiles = 15500;
		mapSizeMultiplier = 2;
	}
	int size = 2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	rmSetMapSize(size, size);
	
	rmSetIgnoreForceToGaia(true);
	rmSetSeaType("mediterranean sea");
	rmTerrainInitialize("grassa");
	rmSetLightingSet("default");
	rmSetGaiaCiv(cCivZeus);
	
	rmSetStatusText("",0.10);
	///CLASSES
	int classStartingSettlement = rmDefineClass("starting settlement");
	int classPlayer 			= rmDefineClass("player");
	int classEdge 				= rmDefineClass("edge");
	int classPond				= rmDefineClass("pond");
	int classCenter				= rmDefineClass("center");
	int classForest				= rmDefineClass("forest");
	int classMisc				= rmDefineClass("misc units");
	int classColumn				= rmDefineClass("column");
	int classIsland				= rmDefineClass("island");
	int classSea				= rmDefineClass("sea");
	int classLand				= rmDefineClass("land");
	
	rmSetStatusText("",0.15);
	///CONSTRAINTS
	int AvoidEdgeFar	= rmCreateBoxConstraint("BC0",rmXTilesToFraction(13), rmZTilesToFraction(13), 1.0-rmXTilesToFraction(13), 1.0-rmZTilesToFraction(13));
	int AvoidEdgeShort	= rmCreateBoxConstraint("BC1",rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));
	
	int AvoidTower		= rmCreateTypeDistanceConstraint("TyDC0", "tower", 22);
	int AvoidAll		= rmCreateTypeDistanceConstraint("TyDC1", "all", 6);
	int AvoidSneks		= rmCreateTypeDistanceConstraint("TyDC2", "sea snake", 20);
	int AvoidHunt		= rmCreateTypeDistanceConstraint("TyDC3", "huntable", 25);
	int AvoidGold		= rmCreateTypeDistanceConstraint("TyDC4", "gold", 30);
	int AvoidSettlement	= rmCreateTypeDistanceConstraint("TyDC5", "abstractSettlement", 18);
	int AvoidPredator	= rmCreateTypeDistanceConstraint("TyDC6", "animalpredator", 25);
	int AvoidHerd		= rmCreateTypeDistanceConstraint("TyDC7", "herdable", 25);
	int AvoidFish		= rmCreateTypeDistanceConstraint("TyDC8", "fish", 24);
	
	int AvoidSettlementFar	= rmCreateTypeDistanceConstraint("TyDC8", "abstractSettlement", 40);
	
	int AvoidPond					= rmCreateClassDistanceConstraint("CDC2", classPond, 25);
	int AvoidPlayer					= rmCreateClassDistanceConstraint("CDC3", classPlayer, 5);
	int AvoidCenter					= rmCreateClassDistanceConstraint("CDC4", classCenter, 20);
	int AvoidForest					= rmCreateClassDistanceConstraint("CDC5", classForest, 20);
	int AvoidMiscUnits				= rmCreateClassDistanceConstraint("CDC6", classMisc, 25);
	int AvoidColumn					= rmCreateClassDistanceConstraint("CDC7", classColumn, 12);
	int AvoidIsland					= rmCreateClassDistanceConstraint("CDC8", classIsland, 12);
	int AvoidStartingSettlementFar	= rmCreateClassDistanceConstraint("CDC9", classStartingSettlement, 50);
	int AvoidSea					= rmCreateClassDistanceConstraint("CDC10", classSea, 1);
	int AvoidLand					= rmCreateClassDistanceConstraint("CDC11", classLand, 35);
	
	int AvoidImpassableLand			= rmCreateTerrainDistanceConstraint("TeDC0", "Land", false, 10.0);
	int AvoidImpassableLandFar		= rmCreateTerrainDistanceConstraint("TeDC1", "Land", false, 15.0);
	int AvoidImpassableLandShort	= rmCreateTerrainDistanceConstraint("TeDC2", "Land", false, 6.0);
	int AvoidImpassableLandShortest	= rmCreateTerrainDistanceConstraint("TeDC3", "Land", false, 1.0);
	int AvoidImpassableWater		= rmCreateTerrainDistanceConstraint("TeDC4", "Land", true, 10.0);
	
	int sharkLand	= rmCreateTerrainDistanceConstraint("shark land", "land", true, 16.0);

	int nearShore	= rmCreateTerrainMaxDistanceConstraint("TMDC0", "Land", true, 50.0);
	int nearLand	= rmCreateTerrainMaxDistanceConstraint("TMDC1", "water", true, 12.0);
	
	int IDRuin = 0;
	int StayInRuins	= rmCreateEdgeDistanceConstraint("E0", IDRuin, 4.0);
	
	rmSetStatusText("",0.20);
	///OBJECT DEFINITIONS	
	int IDStartingSettlement	= rmCreateObjectDef("starting tc");
	rmAddObjectDefItem			(IDStartingSettlement, "settlement level 1", 1, 0);
	rmAddObjectDefToClass		(IDStartingSettlement, classStartingSettlement);
	
	int IDStartingGold			= rmCreateObjectDef("gold");
	rmAddObjectDefItem			(IDStartingGold, "gold mine small", 1, 0);
	rmSetObjectDefMinDistance	(IDStartingGold, 20);
	rmSetObjectDefMaxDistance	(IDStartingGold, 23);
	rmAddObjectDefConstraint	(IDStartingGold, AvoidAll);
	rmAddObjectDefConstraint	(IDStartingGold, AvoidImpassableLand);
	
	int IDStartingTower			= rmCreateObjectDef("tower");
	rmAddObjectDefItem			(IDStartingTower, "tower", 1, 0);
	rmSetObjectDefMinDistance	(IDStartingTower, 20);
	rmSetObjectDefMaxDistance	(IDStartingTower, 27);
	rmAddObjectDefConstraint	(IDStartingTower, AvoidAll);
	rmAddObjectDefConstraint	(IDStartingTower, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDStartingTower, AvoidTower);
	
	int IDStartingChicken		= rmCreateObjectDef("chicken");
	rmAddObjectDefItem			(IDStartingChicken, "chicken", rmRandInt(6,11), 5);
	rmSetObjectDefMinDistance	(IDStartingChicken, 20);
	rmSetObjectDefMaxDistance	(IDStartingChicken, 26);
	rmAddObjectDefConstraint	(IDStartingChicken, AvoidAll);
	rmAddObjectDefConstraint	(IDStartingChicken, AvoidImpassableLand);
	
	int IDStartingHerd			= rmCreateObjectDef("goat");
	rmAddObjectDefItem			(IDStartingHerd, "goat", rmRandInt(1,3), 4);
	rmSetObjectDefMinDistance	(IDStartingHerd, 20);
	rmSetObjectDefMaxDistance	(IDStartingHerd, 30);
	rmAddObjectDefConstraint	(IDStartingHerd, AvoidAll);
	rmAddObjectDefConstraint	(IDStartingHerd, AvoidImpassableLand);
	
	int IDStragglerTree			= rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem			(IDStragglerTree, "pine", 1, 0);
	rmSetObjectDefMinDistance	(IDStragglerTree, 9);
	rmSetObjectDefMaxDistance	(IDStragglerTree, 15);
	rmAddObjectDefConstraint	(IDStragglerTree, AvoidAll);
	
	//medium
	int IDMediumHunt			= rmCreateObjectDef("medium huntable");
	rmAddObjectDefItem			(IDMediumHunt, "elk", rmRandInt(3,6), 5);
	rmSetObjectDefMinDistance	(IDMediumHunt, 50);
	rmSetObjectDefMaxDistance	(IDMediumHunt, 70);
	rmAddObjectDefConstraint	(IDMediumHunt, AvoidAll);
	rmAddObjectDefConstraint	(IDMediumHunt, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDMediumHunt, AvoidHunt);
	rmAddObjectDefConstraint	(IDMediumHunt, AvoidEdgeShort);
	rmAddObjectDefConstraint	(IDMediumHunt, AvoidStartingSettlementFar);
	
	int IDMediumBoar			= rmCreateObjectDef("medium boar");
	rmAddObjectDefItem			(IDMediumBoar, "boar", rmRandInt(1,3), 5);
	rmSetObjectDefMinDistance	(IDMediumBoar, 50);
	rmSetObjectDefMaxDistance	(IDMediumBoar, 70);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidAll);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidHunt);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidEdgeShort);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidStartingSettlementFar);
	
	int IDMediumHerd			= rmCreateObjectDef("medium goat");
	rmAddObjectDefItem			(IDMediumHerd, "goat", rmRandInt(2,3), 3);
	rmSetObjectDefMinDistance	(IDMediumHerd, 50);
	rmSetObjectDefMaxDistance	(IDMediumHerd, 70);
	rmAddObjectDefConstraint	(IDMediumHerd, AvoidAll);
	rmAddObjectDefConstraint	(IDMediumHerd, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDMediumHerd, AvoidHerd);
	rmAddObjectDefConstraint	(IDMediumHerd, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDMediumHerd, AvoidEdgeShort);
	
	int IDMediumGold			= rmCreateObjectDef("medium gold");
	rmAddObjectDefItem			(IDMediumGold, "gold mine", 1, 0);
	rmSetObjectDefMinDistance	(IDMediumGold, 50);
	rmSetObjectDefMaxDistance	(IDMediumGold, 75);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidAll);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidGold);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidSettlement);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidPlayer);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidEdgeShort);
	
	int IDMediumPred			= rmCreateObjectDef("medium pred");
	rmAddObjectDefItem			(IDMediumPred, "bear", rmRandInt(1,3), 3);
	rmSetObjectDefMinDistance	(IDMediumPred, 50);
	rmSetObjectDefMaxDistance	(IDMediumPred, 150);
	rmAddObjectDefConstraint	(IDMediumPred, AvoidAll);
	rmAddObjectDefConstraint	(IDMediumPred, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDMediumPred, AvoidPredator);
	rmAddObjectDefConstraint	(IDMediumPred, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDMediumPred, AvoidEdgeShort);
	
	//far
	int IDFarHunt				= rmCreateObjectDef("far huntable");
	rmAddObjectDefItem			(IDFarHunt, "deer", rmRandInt(3,6), 3);
	rmSetObjectDefMinDistance	(IDFarHunt, 75);
	rmSetObjectDefMaxDistance	(IDFarHunt, 100);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidAll);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidHunt);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidEdgeShort);
	
	int IDFarGold				= rmCreateObjectDef("far gold");
	rmAddObjectDefItem			(IDFarGold, "gold mine", 1, 0);
	rmSetObjectDefMinDistance	(IDFarGold, 70);
	rmSetObjectDefMaxDistance	(IDFarGold, 100);
	rmAddObjectDefConstraint	(IDFarGold, AvoidAll);
	rmAddObjectDefConstraint	(IDFarGold, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDFarGold, AvoidGold);
	rmAddObjectDefConstraint	(IDFarGold, AvoidSettlement);
	rmAddObjectDefConstraint	(IDFarGold, AvoidIsland);
	rmAddObjectDefConstraint	(IDFarGold, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDFarGold, AvoidEdgeShort);
	
	int IDFarHerd				= rmCreateObjectDef("far herd");
	rmAddObjectDefItem			(IDFarHerd, "goat", 2, 4);
	rmSetObjectDefMinDistance	(IDFarHerd, 70);
	rmSetObjectDefMaxDistance	(IDFarHerd, 150);
	rmAddObjectDefConstraint	(IDFarHerd, AvoidAll);
	rmAddObjectDefConstraint	(IDFarHerd, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDFarHerd, AvoidHerd);
	rmAddObjectDefConstraint	(IDFarHerd, AvoidStartingSettlementFar);
	
	int IDVeryFarGold			= rmCreateObjectDef("very far gold");
	rmAddObjectDefItem			(IDVeryFarGold, "gold mine", 1, 0);
	rmSetObjectDefMinDistance	(IDVeryFarGold, 90);
	rmSetObjectDefMaxDistance	(IDVeryFarGold, 120);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidAll);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidGold);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidSettlement);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidStartingSettlementFar);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidPlayer);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidIsland);
	rmAddObjectDefConstraint	(IDVeryFarGold, AvoidEdgeShort);

	//other
	int IDFish					= rmCreateObjectDef("fish");
	rmAddObjectDefItem			(IDFish, "fish - mahi", 3, 10);
	rmSetObjectDefMinDistance	(IDFish, 0);
	rmSetObjectDefMaxDistance	(IDFish, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDFish, AvoidImpassableWater);
	rmAddObjectDefConstraint	(IDFish, AvoidFish);
	rmAddObjectDefConstraint	(IDFish, nearShore);
	
	int IDSnake					= rmCreateObjectDef("sneks");
	rmAddObjectDefItem			(IDSnake, "sea snake", 1, 0);
	rmSetObjectDefMinDistance	(IDSnake, 0);
	rmSetObjectDefMaxDistance	(IDSnake, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDSnake, AvoidImpassableWater);
	rmAddObjectDefConstraint	(IDSnake, AvoidSneks);
	rmAddObjectDefConstraint	(IDSnake, nearShore);
	
	int IDBird					= rmCreateObjectDef("birds");
	rmAddObjectDefItem			(IDBird, "falcon", 1, 0);
	rmSetObjectDefMinDistance	(IDBird, 0);
	rmSetObjectDefMaxDistance	(IDBird, rmXFractionToMeters(0.5));
	
	int IDRandomTree			= rmCreateObjectDef("random pine");
	rmAddObjectDefItem			(IDRandomTree, "pine", 1, 0);
	rmSetObjectDefMinDistance	(IDRandomTree, 0);
	rmSetObjectDefMaxDistance	(IDRandomTree, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDRandomTree, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDRandomTree, AvoidAll);
	
	int IDRandomTree2			= rmCreateObjectDef("random oak autumn");
	rmAddObjectDefItem			(IDRandomTree2, "oak", 1, 0);
	rmSetObjectDefMinDistance	(IDRandomTree2, 0);
	rmSetObjectDefMaxDistance	(IDRandomTree2, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDRandomTree2, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDRandomTree2, AvoidAll);

	int IDWhale					= rmCreateObjectDef("whale");
	rmAddObjectDefItem			(IDWhale, "whale", 1, 0);
	rmSetObjectDefMinDistance	(IDWhale, 0);
	rmSetObjectDefMaxDistance	(IDWhale, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDWhale, sharkLand);
	rmAddObjectDefConstraint	(IDWhale, AvoidEdgeFar);
	
	rmSetStatusText("",0.35);
	///PLAYER PLACEMENT
	if (cNumberNonGaiaPlayers < 3)
	{
	rmPlacePlayersLine(0.25, 0.25, 0.75, 0.75);
	}
	else if (cNumberTeams < 3)
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.12, 0.20, 0.60, 0.20, 0, 0);
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.80, 0.88, 0.80, 0.40, 0, 0);
	} 
	else 
	{
		rmSetPlacementSection(0.15, 0.60);
		rmPlacePlayersCircular(0.37, 0.38, rmDegreesToRadians(0.0));
	}
	
	rmSetStatusText("",0.40);
	///AREA DEFINITION
	int AreaCenter		= rmCreateArea("center");
	rmSetAreaLocation	(AreaCenter, 0.5, 0.5);
	rmSetAreaSize		(AreaCenter, 0.001, 0.001);
	rmAddAreaToClass	(AreaCenter, classCenter);
	rmBuildArea			(AreaCenter);
	
	int AreaSea				= rmCreateArea("sea");
	rmSetAreaSize			(AreaSea, 0.30, 0.30);
	rmSetAreaLocation		(AreaSea, 0.20, 0.80);
	rmSetAreaWaterType		(AreaSea, "mediterranean sea");
	rmSetAreaHeightBlend	(AreaSea, 2);
	rmSetAreaMinBlobs		(AreaSea, 1);
	rmSetAreaMaxBlobs		(AreaSea, 4);
	rmSetAreaMinBlobDistance(AreaSea, 5);
	rmSetAreaMaxBlobDistance(AreaSea, 25);
	rmSetAreaCoherence		(AreaSea, 0.9);
	rmAddAreaToClass		(AreaSea, classSea);
	rmSetAreaSmoothDistance	(AreaSea, 4);
	
	rmBuildArea(AreaSea);
	
	int AreaSeaGulf			= rmCreateArea("sea gulf");
	rmSetAreaSize			(AreaSeaGulf, 0.15, 0.15);
	rmSetAreaLocation		(AreaSeaGulf, 0.4, 0.6);
	rmSetAreaWaterType		(AreaSeaGulf, "mediterranean sea");
	rmSetAreaHeightBlend	(AreaSeaGulf, 2);
	rmSetAreaMinBlobs		(AreaSeaGulf, 2);
	rmSetAreaMaxBlobs		(AreaSeaGulf, 4);
	rmSetAreaMinBlobDistance(AreaSeaGulf, 10);
	rmSetAreaMaxBlobDistance(AreaSeaGulf, 25);
	rmAddAreaToClass		(AreaSeaGulf, classSea);
	rmSetAreaCoherence		(AreaSeaGulf, 0.9);
	
	rmBuildArea(AreaSeaGulf);
	
	for (i = 0; < 5*cNumberNonGaiaPlayers)
	{
		int AreaAvoidSea		= rmCreateArea("constraint reasons"+i);
		rmSetAreaSize			(AreaAvoidSea, 0.3, 0.4);
		rmAddAreaConstraint		(AreaAvoidSea, AvoidSea);
		rmAddAreaToClass		(AreaAvoidSea, classLand);
		rmBuildArea(AreaAvoidSea);
	}
	
	int AreaIsland			= rmCreateArea("mythical island");
	rmSetAreaSize			(AreaIsland, 0.03, 0.035);
	rmSetAreaLocation		(AreaIsland, 0.35, 0.65);
	rmAddAreaToClass		(AreaIsland, classIsland);
	rmAddAreaConstraint		(AreaIsland, AvoidLand);
	rmSetAreaTerrainType	(AreaIsland, "GrassA");
	rmSetAreaBaseHeight		(AreaIsland, 3);
	rmSetAreaHeightBlend	(AreaIsland, 2);
	rmSetAreaMinBlobs		(AreaIsland, 1);
	rmSetAreaMaxBlobs		(AreaIsland, 5);
	rmSetAreaMinBlobDistance(AreaIsland, 5);
	rmSetAreaMaxBlobDistance(AreaIsland, 20);
	rmSetAreaCoherence		(AreaIsland, 0.6);
	rmSetAreaSmoothDistance	(AreaIsland, 1);
	
	rmBuildArea(AreaIsland);
	
	for (i = 1; < cNumberPlayers) {
		int AreaPlayer			= rmCreateArea("player area"+i);
		rmSetAreaSize			(AreaPlayer, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		rmSetAreaLocPlayer		(AreaPlayer, i);
		rmSetAreaCoherence		(AreaPlayer, 0.8);
		rmSetAreaMinBlobs		(AreaPlayer, 1);
		rmSetAreaMaxBlobs		(AreaPlayer, 4);
		rmSetAreaMinBlobDistance(AreaPlayer, 10);
		rmSetAreaMaxBlobDistance(AreaPlayer, 20);
		rmSetAreaTerrainType	(AreaPlayer, "GrassB");
		rmAddAreaTerrainLayer	(AreaPlayer, "GrassA", 3, 5);
		rmAddAreaTerrainLayer	(AreaPlayer, "grassdirt25", 0, 3);
		rmSetAreaBaseHeight		(AreaPlayer, 1);
		rmSetAreaHeightBlend	(AreaPlayer, 2);
		rmAddAreaToClass		(AreaPlayer, classPlayer);
		rmAddAreaConstraint		(AreaPlayer, AvoidPlayer);
	}
	rmBuildAllAreas();
	
	for (i = 1; < cNumberPlayers*6) {
		int AreaElev			= rmCreateArea("elev"+i);
		rmSetAreaSize			(AreaElev, rmAreaTilesToFraction(50), rmAreaTilesToFraction(150));
		rmSetAreaTerrainType	(AreaElev, "GrassB");
		rmAddAreaTerrainLayer	(AreaElev, "grassA", 0, 1);
		rmAddAreaConstraint		(AreaElev, AvoidImpassableLand);
		rmSetAreaBaseHeight		(AreaElev, rmRandFloat(3,6));
		rmSetAreaHeightBlend	(AreaElev, 2.0);
		rmSetAreaCoherence		(AreaElev, 0.5);
		
		rmBuildArea(AreaElev);
	}
	
	IDRuin					= rmCreateArea("ruins ");
	rmSetAreaSize			(IDRuin, 0.01, 0.01);
	rmSetAreaTerrainType	(IDRuin, "GreekRoadA");
	rmAddAreaTerrainLayer	(IDRuin, "GrassA", 0, 1);
	rmSetAreaLocation		(IDRuin, 0.35, 0.65);
	rmSetAreaMinBlobs		(IDRuin, 1);
	rmSetAreaMaxBlobs		(IDRuin, 4);
	rmSetAreaWarnFailure	(IDRuin, false); 
	rmSetAreaMinBlobDistance(IDRuin, 16.0);
	rmSetAreaMaxBlobDistance(IDRuin, 40.0);
	rmSetAreaCoherence		(IDRuin, 0.6);
	rmAddAreaConstraint		(IDRuin, AvoidAll);
	rmAddAreaConstraint		(IDRuin, StayInRuins);
	rmAddAreaConstraint		(IDRuin, AvoidImpassableLandShortest);
	
	rmBuildArea(IDRuin);
	
	int IDRelic					= rmCreateObjectDef("relics ");
	rmAddObjectDefItem			(IDRelic, "relic", 1, 5.0);
	rmSetObjectDefMinDistance	(IDRelic, 0.0);
	rmSetObjectDefMaxDistance	(IDRelic, 0.0);
	rmAddObjectDefConstraint	(IDRelic, AvoidAll);
	rmAddObjectDefConstraint	(IDRelic, StayInRuins);
	rmPlaceObjectDefInArea		(IDRelic, 0, rmAreaID("ruins "), 3);
	
	int IDFleece				= rmCreateObjectDef("fleece");
	rmAddObjectDefItem			(IDFleece, "golden fleece", 1, 0.0);
	rmSetObjectDefMinDistance	(IDFleece, 0.0);
	rmSetObjectDefMaxDistance	(IDFleece, 0.0);
	rmAddObjectDefConstraint	(IDFleece, AvoidAll);
	rmAddObjectDefConstraint	(IDFleece, StayInRuins);
	rmAddObjectDefConstraint	(IDFleece, AvoidImpassableLand);
	rmPlaceObjectDefInArea		(IDFleece, 0, rmAreaID("ruins "), 1);
	
	int IDColumn				= rmCreateObjectDef("columns ");
	rmAddObjectDefItem			(IDColumn, "ruins", rmRandInt(0,2), 5.0);
	rmAddObjectDefItem			(IDColumn, "columns broken", rmRandInt(2,6), 6.0);
	rmAddObjectDefItem			(IDColumn, "columns", rmRandFloat(0,3), 4.0);
	rmAddObjectDefItem			(IDColumn, "rock limestone small", rmRandInt(1,4), 4.0);
	rmAddObjectDefItem			(IDColumn, "rock limestone sprite", rmRandInt(6,12), 6.0);
	rmAddObjectDefItem			(IDColumn, "grass", rmRandFloat(3,6), 6.0);
	rmSetObjectDefMinDistance	(IDColumn, 0.0);
	rmSetObjectDefMaxDistance	(IDColumn, 0.0);
	rmAddObjectDefConstraint	(IDColumn, AvoidImpassableLand);
	rmAddObjectDefConstraint	(IDColumn, AvoidColumn);
	rmAddObjectDefToClass		(IDColumn, classColumn);
	rmPlaceObjectDefInArea		(IDColumn, 0, rmAreaID("ruins "), 1);
	
	int IDColumn2				= rmCreateObjectDef("columns2 ");
	rmAddObjectDefItem			(IDColumn2, "ruins", rmRandInt(0,2), 5.0);
	rmAddObjectDefItem			(IDColumn2, "columns broken", rmRandInt(2,6), 6.0);
	rmAddObjectDefItem			(IDColumn2, "columns", rmRandFloat(0,3), 4.0);
	rmAddObjectDefItem			(IDColumn2, "rock limestone small", rmRandInt(1,4), 4.0);
	rmAddObjectDefItem			(IDColumn2, "rock limestone sprite", rmRandInt(6,12), 6.0);
	rmAddObjectDefItem			(IDColumn2, "grass", rmRandFloat(3,6), 6.0);
	rmSetObjectDefMinDistance	(IDColumn2, 0.0);
	rmSetObjectDefMaxDistance	(IDColumn2, 0.0);
	rmAddObjectDefConstraint	(IDColumn2, AvoidImpassableLandShort);
	rmAddObjectDefConstraint	(IDColumn2, AvoidColumn);
	rmAddObjectDefToClass		(IDColumn2, classColumn);
	rmPlaceObjectDefInArea		(IDColumn2, 0, rmAreaID("ruins "), 1);
	
	int StrongDefenderNum = rmRandInt(0, 100);
	
	int IDRuinDefenders			= rmCreateObjectDef("defenders ");
	rmAddObjectDefItem			(IDRuinDefenders, "cyclops", rmRandInt(1,2), 8.0);
	rmAddObjectDefItem			(IDRuinDefenders, "centaur", rmRandInt(2,4), 14.0);
	
	if (StrongDefenderNum < 20)
	{
		rmAddObjectDefItem			(IDRuinDefenders, "colossus", rmRandInt(0,2), 6.0);
		rmAddObjectDefItem			(IDRuinDefenders, "medusa", rmRandInt(0,2), 8.0);
	}
	rmSetObjectDefMinDistance	(IDRuinDefenders, 0.0);
	rmSetObjectDefMaxDistance	(IDRuinDefenders, 0.0);
	rmAddObjectDefConstraint	(IDRuinDefenders, AvoidImpassableLand);
	rmPlaceObjectDefInArea		(IDRuinDefenders, 0, rmAreaID("ruins "), 0.5*cNumberNonGaiaPlayers);
	
	int IDRuinTrees				= rmCreateObjectDef("ruin trees ");
	rmAddObjectDefItem			(IDRuinTrees, "oak", 1, 0.0);
	rmSetObjectDefMinDistance	(IDRuinTrees, 0.0);
	rmSetObjectDefMaxDistance	(IDRuinTrees, 0.0);
	rmAddObjectDefConstraint	(IDRuinTrees, AvoidImpassableLandShort);
	rmPlaceObjectDefInArea		(IDRuinTrees, 0, rmAreaID("mythical island"), rmRandInt(2, 4)*cNumberNonGaiaPlayers);
	
	rmSetStatusText("",0.50);
	///SETTLEMENTS	
	rmPlaceObjectDefPerPlayer(IDStartingSettlement, true);
	
	int SettleArea	= rmAddFairLoc("Settlement", false, true,  65, 90, 40, 15);
	rmAddFairLocConstraint(SettleArea, AvoidImpassableLandFar);
	rmAddFairLocConstraint(SettleArea, AvoidIsland);
	
	SettleArea		= rmAddFairLoc("Settlement", true, false,  75, 100, 75, 15);
	rmAddFairLocConstraint(SettleArea, AvoidImpassableLandFar);
	rmAddFairLocConstraint(SettleArea, AvoidIsland);
	
	if(rmPlaceFairLocs())
	{
		SettleArea = rmCreateObjectDef("far settlement2");
		rmAddObjectDefItem(SettleArea, "Settlement", 1, 0.0);
		for(i = 1; < cNumberPlayers)
		{
			for(j = 0; < rmGetNumberFairLocs(i))
				rmPlaceObjectDefAtLoc(SettleArea, 0, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
		}
	}
	
	rmSetStatusText("",0.5);
	///PLACE OBJECTS
	rmPlaceObjectDefPerPlayer(IDStartingGold, false);
	rmPlaceObjectDefPerPlayer(IDStartingTower, true, 4);
	rmPlaceObjectDefPerPlayer(IDStartingChicken, false);
	rmPlaceObjectDefPerPlayer(IDStartingHerd, true);
	rmPlaceObjectDefPerPlayer(IDStragglerTree, false);
	
	rmPlaceObjectDefPerPlayer(IDMediumHunt, false);
	rmPlaceObjectDefPerPlayer(IDMediumBoar, false);
	rmPlaceObjectDefPerPlayer(IDMediumGold, false);
	rmPlaceObjectDefPerPlayer(IDMediumPred, false);
	rmPlaceObjectDefPerPlayer(IDMediumHerd, false);
	
	rmPlaceObjectDefPerPlayer(IDFarGold, false, 2);
	rmPlaceObjectDefPerPlayer(IDVeryFarGold, false);
	rmPlaceObjectDefPerPlayer(IDFarHunt, false);
	rmPlaceObjectDefPerPlayer(IDFarHerd, false, rmRandInt(2, 3));
	
	rmPlaceObjectDefAtLoc	 (IDFish, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
	rmPlaceObjectDefPerPlayer(IDSnake, false, rmRandInt(1,2)*cNumberNonGaiaPlayers);
	rmPlaceObjectDefPerPlayer(IDBird, false, 2);
	rmPlaceObjectDefPerPlayer(IDWhale, false, 2);
	rmSetStatusText("",0.70);
	///ELEV
	
	rmSetStatusText("",0.80);
	///FORESTS	
	for (i = 1; < cNumberNonGaiaPlayers*9) {
		int AreaForest			 = rmCreateArea("forests"+i);
		rmSetAreaSize			(AreaForest, rmAreaTilesToFraction(40), rmAreaTilesToFraction(80));
		
		if (rmRandInt (1, 2) < 2)
			rmSetAreaForestType		(AreaForest, "pine forest");
		else
			rmSetAreaForestType		(AreaForest, "Oak Forest");
		
		rmSetAreaCoherence		(AreaForest, 0.2);
		rmAddAreaToClass		(AreaForest, classForest);
		rmAddAreaConstraint		(AreaForest, AvoidForest);
		rmAddAreaConstraint		(AreaForest, AvoidImpassableLand);
		rmAddAreaConstraint		(AreaForest, AvoidPlayer);
		rmAddAreaConstraint		(AreaForest, AvoidAll);
		rmBuildArea				(AreaForest);
	}
	
	
	rmPlaceObjectDefAtLoc(IDRandomTree, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
	rmPlaceObjectDefAtLoc(IDRandomTree2, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
	rmSetStatusText("",0.90);
	///BEAUTIFICATION
	int IDSeaweed				= rmCreateObjectDef("seaweed");
	rmAddObjectDefItem			(IDSeaweed, "seaweed", 1, 0);
	rmSetObjectDefMinDistance	(IDSeaweed, 0);	
	rmSetObjectDefMaxDistance	(IDSeaweed, rmXFractionToMeters(0.5));
	rmPlaceObjectDefAtLoc		(IDSeaweed, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
	
	int IDGrass					= rmCreateObjectDef("grass");
	rmAddObjectDefItem			(IDGrass, "grass", 1, 0);
	rmSetObjectDefMinDistance	(IDGrass, 0);	
	rmSetObjectDefMaxDistance	(IDGrass, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDGrass, AvoidImpassableLandShortest);
	rmPlaceObjectDefAtLoc		(IDGrass, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);
	
	int IDRock					= rmCreateObjectDef("rock");
	rmAddObjectDefItem			(IDGrass, "rock limestone sprite", 3, 3);
	rmSetObjectDefMinDistance	(IDGrass, 0);	
	rmSetObjectDefMaxDistance	(IDGrass, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDGrass, AvoidImpassableLandShortest);
	rmPlaceObjectDefAtLoc		(IDGrass, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
	
	int IDBush					= rmCreateObjectDef("bush");
	rmAddObjectDefItem			(IDBush, "bush", 1, 0);
	rmSetObjectDefMinDistance	(IDBush, 0);	
	rmSetObjectDefMaxDistance	(IDBush, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint	(IDBush, AvoidImpassableLandShortest);
	rmPlaceObjectDefAtLoc		(IDBush, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
	
	rmSetStatusText("",1.00);
	///TRIGGERS
	for(i=1; <cNumberPlayers){
		rmCreateTrigger("StartCountdown"+i);
		rmCreateTrigger("CountdownWarning"+i);
		rmCreateTrigger("CriticalCountdownWarning"+i);
		rmCreateTrigger("StopCountdown"+i);
		rmCreateTrigger("Victory"+i);
	}
	
	// Start countdown when Player has Vault
	for(i=1; <cNumberPlayers){
		rmSwitchToTrigger(rmTriggerID("StartCountdown"+i));
		rmSetTriggerActive(true);
		
		rmAddTriggerCondition("Player Unit Count");
		rmSetTriggerConditionParamInt("PlayerID", i);
		rmSetTriggerConditionParam("ProtoUnit", "Golden Fleece");
		rmSetTriggerConditionParam("Op", ">");
		rmSetTriggerConditionParamInt("Count", 0);
		
		rmAddTriggerEffect("Send Chat");
		rmSetTriggerEffectParamInt("PlayerID", 0);
		rmSetTriggerEffectParam("Message", "{PlayerName("+i+")} has captured the Golden Fleece! Countdown begins!");
		
		rmAddTriggerEffect("Sound Filename");
		rmSetTriggerEffectParam("Sound", "Fanfare.wav");
		
		rmAddTriggerEffect("Counter:Add Timer");
		rmSetTriggerEffectParam("Name", "victoryCounter"+i);
		rmSetTriggerEffectParamInt("Start",480);
		rmSetTriggerEffectParamInt("Stop",120);
		rmSetTriggerEffectParam("Msg", "Time until {PlayerName("+i+")} wins by controlling the Fleece");
		rmSetTriggerEffectParamInt("Event", rmTriggerID("CountdownWarning"+i));
		
		rmAddTriggerEffect("Fire Event");
		rmSetTriggerEffectParamInt("EventID", rmTriggerID("StopCountdown"+i));
	}
	
	// Warn players when Countdown = 2 minutes
	for(i=1; <cNumberPlayers){
		rmSwitchToTrigger(rmTriggerID("CountdownWarning"+i));
		rmSetTriggerActive(false);
		
		rmAddTriggerEffect("Send Chat");
		rmSetTriggerEffectParamInt("PlayerID", 0);
		rmSetTriggerEffectParam("Message", "{PlayerName("+i+")} will win the game if he holds the Fleece for 2 more minutes!");
		
		rmAddTriggerEffect("Sound Filename");
		rmSetTriggerEffectParam("Sound", "Fanfare.wav");
		
		rmAddTriggerEffect("Counter:Add Timer");
		rmSetTriggerEffectParam("Name", "victoryCounter2"+i);
		rmSetTriggerEffectParamInt("Start",120);
		rmSetTriggerEffectParamInt("Stop",30);
		rmSetTriggerEffectParam("Msg", "Time until {PlayerName("+i+")} wins by controlling the Fleece");
		rmSetTriggerEffectParamInt("Event", rmTriggerID("CriticalCountdownWarning"+i));
	}
	
	// Warn players when Countdown = 30 seconds
	for(i=1; <cNumberPlayers){
		rmSwitchToTrigger(rmTriggerID("CriticalCountdownWarning"+i));
		rmSetTriggerActive(false);
		
		rmAddTriggerEffect("Send Chat");
		rmSetTriggerEffectParamInt("PlayerID", 0);
		rmSetTriggerEffectParam("Message", "{PlayerName("+i+")} is about to win by controlling the Fleece!");
		
		rmAddTriggerEffect("Sound Filename");
		rmSetTriggerEffectParam("Sound", "Fanfare.wav");
		
		rmAddTriggerEffect("Counter:Add Timer");
		rmSetTriggerEffectParam("Name", "victoryCounter3"+i);
		rmSetTriggerEffectParamInt("Start",30);
		rmSetTriggerEffectParamInt("Stop",0);
		rmSetTriggerEffectParam("Msg", "Time until {PlayerName("+i+")} wins by controlling the Fleece");
		rmSetTriggerEffectParamInt("Event", rmTriggerID("Victory"+i));
	}
	
	// Stop countdown when Player loses Vault
	for(i=1; <cNumberPlayers){
		rmSwitchToTrigger(rmTriggerID("StopCountdown"+i));
		rmSetTriggerActive(false);
		
		rmAddTriggerCondition("Player Unit Count");
		rmSetTriggerConditionParamInt("PlayerID", i);
		rmSetTriggerConditionParam("ProtoUnit", "Golden Fleece");
		rmSetTriggerConditionParam("Op", "<");
		rmSetTriggerConditionParamInt("Count", 1);
		
		rmAddTriggerEffect("Counter Stop");
		rmSetTriggerEffectParam("Name", "victoryCounter"+i);
		
		rmAddTriggerEffect("Counter Stop");
		rmSetTriggerEffectParam("Name", "victoryCounter2"+i);
		
		rmAddTriggerEffect("Counter Stop");
		rmSetTriggerEffectParam("Name", "victoryCounter3"+i);
		
		rmAddTriggerEffect("Send Chat");
		rmSetTriggerEffectParamInt("PlayerID", 0);
		rmSetTriggerEffectParam("Message", "{PlayerName("+i+")} lost control of the Golden Fleece!");
		
		rmAddTriggerEffect("Fire Event");
		rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartCountdown"+i));
	}
	
	// Declare Victory when countdown done
	for(i=1; <cNumberPlayers){
		rmSwitchToTrigger(rmTriggerID("Victory"+i));
		rmSetTriggerActive(false);
		
		rmAddTriggerEffect("Send Chat");
		rmSetTriggerEffectParamInt("PlayerID", 0);
		rmSetTriggerEffectParam("Message", "{PlayerName("+i+")} has won the game by controlling the Fleece!");
		
		rmAddTriggerEffect("Sound Filename");
		rmSetTriggerEffectParam("Sound", "Fanfare.wav");
		
		rmAddTriggerEffect("Set Player Won");
		rmSetTriggerEffectParamInt("Player", i);
	}
}